Subject: [PATCH v3 08/11] KVM: arm: implement dirty bit mechanism for debug registers

From: [email-masked] (Will Deacon)
Date: Tue, 7 Jul 2015 11:24:06 +0100

On Tue, Jul 07, 2015 at 11:06:57AM +0100, Zhichao Huang wrote:
> Chazy and me are talking about how to reduce the saving/restoring
> overhead for debug registers.
> We want to add a state in hw_breakpoint.c to indicate whether the host
> enable any hwbrpts or not (might export a fuction that kvm can call),
> then we can read this state from memory instead of reading from real
> hardware registers, and to decide whether we need a world switch or
> not.
> Does it acceptable?

Maybe, hard to tell without the code. There are obvious races to deal with
if you use variables to indicate whether resources are in use -- why not
just trap debug access from the host as well? Then you could keep track of
the "owner" in kvm and trap accesses from everybody else.

Will